# This job will be send email for notify approver approve job with email in $NOTIFY_MAIL_LIST
.notify-approve: &notify-approve
  stage: approval
  image: bytekode/ssmtp
  tags:
    - docker-itsd
  variables:
    GIT_STRATEGY: none
  cache: {}
  script:
    - |
        \
        # Log pipeline console
        \
        echo "Sending approve request notification to ${NOTIFY_MAIL_LIST}"
    - | 
        \
        # Config SMTP
        cat > /etc/ssmtp/ssmtp.conf <<EOF
        mailhub=${SMTP_HOST}:${SMTP_PORT}
        FromLineOverride=YES
        EOF
    - | 
        \
        # Create mail content
        cat > mail.txt <<EOF
        To: ${NOTIFY_MAIL_LIST}
        From: ITSD CI Bot <${GITLAB_USER_EMAIL}>
        Subject: [CI-${CI_PIPELINE_ID}] Approval request for rollout ${CI_PROJECT_NAME} deployment on Kubernetes cluster

        Dear Authorizer

         Please be considered to approve for rollout ${CI_PROJECT_NAME} on production environment. 

         ${CI_PIPELINE_URL}


        Regards,

        ${GITLAB_USER_NAME}
        ${CI_PROJECT_NAME}'s maintainer 

        EOF
    - |
        \
        cat mail.txt
    - |
        \
        # Sending Email to notify 
        ssmtp ${NOTIFY_MAIL_LIST} < mail.txt && \
        \
        echo "Successful sent email from ${GITLAB_USER_EMAIL} to notify approvers."

# Notify approve on PROD environment
1-Request approve:
  extends: .notify-approve
  only:
    - /^prod[\/\-][\d]+(\.\d+){0,2}$/
    - /^v[\.\-][\d]+(\.\d+){0,2}$/
  before_script: 
    - |
        \
        # Defined mail list
        export NOTIFY_MAIL_LIST=${EMAIL_APPROVAL_CC},${EMAIL_APPROVAL_ITO}

.approve: &approve
  stage: approval
  when: manual
  tags: 
    - docker-itsd
  variables:
    GIT_STRATEGY: none
  before_script:
    - | # Checking privilege
        \
        echo "Checking privileged of ${GITLAB_USER_EMAIL} to do ${CI_JOB_NAME}"
  script:
    - | # Audit log
        \
        echo "[${APPROVER_ROLE}] ${GITLAB_USER_EMAIL} approved."
        # [TODO] Add approve detail to cache file for using at next stage
      
    
.approve-qa: &approve-qa
  <<: *approve
  only:
    - /^qa[\/\-].+$/

.approve-prod: &approve-prod
  <<: *approve
  only:
    - /^prod[\/\-][\d]+(\.\d+){0,3}$/
  

2_QA Approve:
  <<: *approve-qa
  variables:
    APPROVER_ROLE: TEST_LEAD
    APPROVER_PREFIX: QA_LEAD     # This value use to identify Email list.  eg. QA_LEAD_EMAILS 

2_CC Approve:
  <<: *approve-prod
  variables: 
    APPROVER_ROLE: CC-Coordinator
    APPROVER_PREFIX: CC

2_ITO Approve:
  <<: *approve-prod
  variables: 
    APPROVER_ROLE: IT-Operation
    APPROVER_PREFIX: ITO
